/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.SecIdentity;

import dstep.corefoundation.CFArray;
import dstep.corefoundation.CFBase;
import dstep.security.SecBase;
import dstep.security.cssmtype;

extern (C)
{
	extern
	{
		const CFStringRef kSecIdentityDomainDefault;
		const CFStringRef kSecIdentityDomainKerberosKDC;
	}
}

extern (C)
{
	uint SecIdentityGetTypeID ();
	int SecIdentityCreateWithCertificate (CFTypeRef keychainOrArray, SecCertificateRef certificateRef, SecIdentityRef* identityRef);
	int SecIdentityCopyCertificate (SecIdentityRef identityRef, SecCertificateRef* certificateRef);
	int SecIdentityCopyPrivateKey (SecIdentityRef identityRef, SecKeyRef* privateKeyRef);
	int SecIdentityCopyPreference (CFStringRef name, uint keyUsage, CFArrayRef validIssuers, SecIdentityRef* identity);
	int SecIdentitySetPreference (SecIdentityRef identity, CFStringRef name, uint keyUsage);
	int SecIdentityCopySystemIdentity (CFStringRef domain, SecIdentityRef* idRef, CFStringRef* actualDomain);
	int SecIdentitySetSystemIdentity (CFStringRef domain, SecIdentityRef idRef);
}